﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

//FD
//FD namespaces
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.Storage;
using Microsoft.WindowsAzure.Storage.Auth;
using Microsoft.WindowsAzure.Storage.Blob;
using System.IO;

namespace ConsoleApplication1
{   
    class Program
    {
        static string sStorage = "storage";
        static string sContainer = "containertest";

        static void Menu()
        {
            Console.WriteLine("0. Create Container" +
                Environment.NewLine + "1. List Blobs" +
                Environment.NewLine + "2. Insert Blob" +
                Environment.NewLine + "3. Delete Blob" + 
                Environment.NewLine + "9. Exit" );
            var answer = Console.ReadLine();

            int choice = 0;

            if (int.TryParse(answer, out choice))
            {
                switch (choice)
                {
                    case 0:  //Create container
                        CreateContainer();
                        break;
                    case 1:  //List Blobs
                        ListBlobs();
                        break;
                    //something for option 2  
                    case 2:  //Insert Blob
                        InsertBlob();
                        break;
                    //something for option 3  
                    case 3:  //Delete Blob
                        DeleteBlob();
                        break;
                    case 9:
                        Environment.Exit(-1);
                        break;
                    default:
                        Console.WriteLine("Wrong selection!" +
                        Environment.NewLine + "Press any key for exit");
                        Console.ReadKey();
                        break;
                }

            }
            else
            {
                Console.WriteLine("You must type numeric value only!" +

                Environment.NewLine + "Press any kay for exit");

                Console.ReadKey();

            }  
        }
        
        static void CreateContainer()
        {
            /*
            StorageCredentials sc = new StorageCredentials("[storage account name]","[storage account key]");
            CloudStorageAccount storageAccount = new CloudStorageAccount(sc, true);
             */

            //FD gets the storage account connection string
            //CloudStorageAccount storageAccount = CloudStorageAccount.Parse(CloudConfigurationManager.GetSetting(sStorage));
            
            CloudStorageAccount storageAccount = CloudStorageAccount.DevelopmentStorageAccount;

            //Creates the blob service client
            CloudBlobClient blobClient = storageAccount.CreateCloudBlobClient();

            // Retrieve a reference to a container. 
            CloudBlobContainer container = blobClient.GetContainerReference(sContainer);

            // Create the container if it doesn't already exist.
            container.CreateIfNotExists();

            //FD by default the container is set to private (in this case we apply the public permission)
            container.SetPermissions(
                new BlobContainerPermissions
                {
                    PublicAccess = BlobContainerPublicAccessType.Blob
                });

            //FD print the container URI
            Console.WriteLine(container.Uri.ToString());
            Console.ReadLine();
            Console.Clear();
            Menu();

        }
        
        static void ListBlobs()
        {
            //FD list the blobs inside the container

            /*
            StorageCredentials sc = new StorageCredentials("[storage account name]","[storage account key]");
            CloudStorageAccount storageAccount = new CloudStorageAccount(sc, true);
             */

            // Retrieve storage account from connection string.
            CloudStorageAccount storageAccount = CloudStorageAccount.DevelopmentStorageAccount;

            // Create the blob client.
            CloudBlobClient blobClient = storageAccount.CreateCloudBlobClient();

            // Retrieve reference to a previously created container.
            CloudBlobContainer container = blobClient.GetContainerReference(sContainer);

            // Loop over items within the container and output the length.
            foreach (IListBlobItem item in container.ListBlobs(null, true))
            {
                if (item.GetType() == typeof(CloudBlockBlob))
                {
                    Console.WriteLine("block:" + item.Uri.ToString());
                }
                else if (item.GetType() == typeof(CloudPageBlob))
                {
                    Console.WriteLine("page: " + item.Uri.ToString());
                }
                else if (item.GetType() == typeof(CloudBlobDirectory))
                {
                    Console.WriteLine("dir: " + item.Uri.ToString());
                }
            }
            Console.ReadLine();
            Console.Clear();
            Menu();
            
        }
        
        
        [STAThreadAttribute]
        static void InsertBlob()
        {
            OpenFileDialog myFile = new OpenFileDialog();
            myFile.ShowDialog();

            /*
            StorageCredentials sc = new StorageCredentials("[storage account name]","[storage account key]");
            CloudStorageAccount storageAccount = new CloudStorageAccount(sc, true);
             */

            // Retrieve storage account from connection string.
            CloudStorageAccount storageAccount = CloudStorageAccount.DevelopmentStorageAccount;

            // Create the blob client.
            CloudBlobClient blobClient = storageAccount.CreateCloudBlobClient();

            // Retrieve reference to a previously created container.
            CloudBlobContainer container = blobClient.GetContainerReference(sContainer);

            // Retrieve reference to a blob 
            //CloudBlockBlob blockBlob = container.GetBlockBlobReference(myFile.FileName);
            FileInfo fi = new FileInfo(myFile.FileName);
            string sName = fi.Name;
            
            CloudBlockBlob blockBlob = container.GetBlockBlobReference(sName);
            Stream s = myFile.OpenFile();
            blockBlob.UploadFromStream(s);

            Console.WriteLine("File Uploaded");
            Console.ReadLine();
            Console.Clear();
            Menu();    
        }

        static void DeleteBlob()
        {
            /*
            StorageCredentials sc = new StorageCredentials("[storage account name]","[storage account key]");
            CloudStorageAccount storageAccount = new CloudStorageAccount(sc, true);
             */
            
            // Retrieve storage account from connection string.
            CloudStorageAccount storageAccount = CloudStorageAccount.DevelopmentStorageAccount;

            // Create the blob client.
            CloudBlobClient blobClient = storageAccount.CreateCloudBlobClient();

            // Retrieve reference to a previously created container.
            CloudBlobContainer container = blobClient.GetContainerReference(sContainer);

            Console.WriteLine("Insert the name of the blob");
            string filename = Console.ReadLine();
            // Get the file name
            CloudBlockBlob blockBlob = container.GetBlockBlobReference(filename);

            // Delete the blob.
            if (blockBlob.DeleteIfExists())
                Console.WriteLine("File Deleted");
            else
                Console.WriteLine("File not found");
            Console.ReadLine();
            Console.Clear();
            Menu();
        }

        
        [STAThreadAttribute]
        static void Main(string[] args)
        {

            Menu();
                  
        }
    }
}
